#!/bin/bash

echo Exporting files.
svn export https://questhelperredux.googlecode.com/svn/trunk/ build
let version=`svnversion`

cd build

echo Replacing version tag.
sed -i "s/\\\$svnversion\\\$/${version}b/g" QuestHelper/QuestHelper.toc

echo Zipping up the package.
zip -vr QuestHelper_Redux-4.0.1.${version}b.zip QuestHelper/

echo Moving the package up one directory level.
mv -v *.zip ..

cd ..

echo Cleaning up.
rm -rvf build

echo Completed exporting and packaging revision $version
